<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Based on Dan Ellis' test scripts that came with sieve-php.lib
 * <danellis@rushmore.com> <URL:http://sieve-php.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* addrule.php: Wizard-like form for adding new rules. */

define('SM_PATH','../../');
require_once('../../functions/strings.php');
require_once("avelsieve_support.inc.php");

if (avelsieve_check_SM_version(1,3,2)) { /* New way for Squirrelmail >= 1.3.2! */
	require_once(SM_PATH . 'include/validate.php');
	require_once(SM_PATH . 'include/load_prefs.php');
	require_once(SM_PATH . 'functions/global.php');
	require_once(SM_PATH . 'functions/page_header.php');
	require_once(SM_PATH . 'functions/i18n.php');
	require_once(SM_PATH . 'functions/imap.php');
//	require_once(SM_PATH . 'functions/strings.php');

} else {

	chdir('..');
	require_once('../src/validate.php');
	require_once('../functions/i18n.php');
	require_once('../functions/strings.php');
	require_once('../config/config.php');
	require_once('../src/load_prefs.php');
	require_once('../functions/prefs.php');
	require_once('../functions/imap.php');
	require_once('../functions/plugin.php');
	require_once('../functions/constants.php');
	// require_once('../functions/page_header.php');
	require_once('../functions/imap_utf7_decode_local.php');
	chdir('avelsieve');
}

include "config.php";
require_once "table_html.php";
require_once "addrule_html.php";
require_once "buildrule.php";

if (!avelsieve_check_SM_version(1,3,2)) { /* for old squirrelmail, stay at plugins/ */
	chdir('..');
}


sqsession_is_active();



if(isset($_SESSION['sess'])) {
	$newrule = $_SESSION['sess'];
}

//print_r($newrule);




if($_POST['cancel']) {
	unset($_SESSION['sess']);
	session_unregister('sess');
	unset($part);
	session_unregister('part');
	/* header("Location: https://".$HTTP_SERVER_VARS['HTTP_HOST']."/".
		dirname($HTTP_SERVER_VARS['PHP_SELF'])."/".table.php"); */
	header("Location: ./table.php");
	exit;
}

/* TO CHECK */
//if($_SESSION['sess']['type'] == 4) {
//	$part = 3;
//}

/* Where are we? (aka $part)
   * not set or 1 => 1/4 to 2/4
   * 2            => 2/4 to 3/4
   * 3            => 3/4 to 4/4
   * 4            => 4/4 to end.
*/
	

if($_POST['startover'] ||  !$_SESSION['part'] || $_POST['add'] ) {
	$part = "1";
	$_SESSION['part'] = 1;
}

if(isset($_SESSION['part'])) {
	$part = $_SESSION['part'];
}

if($_POST['next']) {
	$part++;
} elseif($_POST['prev']) {
	$part--;
}

if($part==2 && $_POST['next']) {
	$newrule['type'] = $_POST['type']; 
}

if($_POST['append']) {
	$part=2;
	if (!isset($_POST['items'])) {
		$items = $startitems;
	} else {
		$items = $_POST['items'] + 1;
	}
} elseif($_POST['less']) {
	$part=2;
	if (!isset($_POST['items'])) {
		$items = $startitems;
	} else {
		$items = $_POST['items'] - 1;
	}
} else {
	$items = $startitems;
}

if(($newrule['type']==4) && ($part==2)) {
 	$part++;

}

$_SESSION['part'] = $part;

/* End of "where we are" thingie */



if(($createnewfolder == true ) && ($_POST['action'] == 5) && 
($_POST['newfolder'] == "5b" ) && !$_POST['startover'] && !$_POST['cancel']) {
	/* User asked to create a new folder... Variables:
		$folder_name = name of folder to create
		$subfolder   = name of folder under which to create $folder_name
	*/
	/* Copy & paste magic (aka kludge) */
	global $mailboxlist, $edunetmode, $delimiter, $addrule_error;

	if(isset($_SESSION['delimiter'])) {
		$delimiter = $_SESSION['delimiter'];
	} else { /* These aren't likely to be executed.. just in case... */
		$delimiter = sqimap_get_delimiter($imapConnection);
		$_SESSION['delimiter'] = $delimiter;
	}

	if(isset($_POST['folder_name'])) {
		$folder_name = imap_utf7_encode_local(trim($_POST['folder_name']));
	}

	if(isset($_POST['subfolder'])) {
		$subfolder = $_POST['subfolder'];
	} else {
		$subfolder = "INBOX";
	}

	if (strpos($folder_name, "\"") || strpos($folder_name, "\\") ||
	strpos($folder_name, "'") || strpos($folder_name, "$delimiter")) {
		$part--;
		$_SESSION['part'] = $part;
		$addrule_error = _("Illegal folder name.  Please select a different name"); 
	}

	if (isset($contain_subs) && $contain_subs ) {
		$folder_name = "$folder_name$delimiter";
	}

	if ($folder_prefix && (substr($folder_prefix, -1) != $delimiter)) {
		$folder_prefix = $folder_prefix . $delimiter;
	}
	if ($folder_prefix && (substr($subfolder, 0, strlen($folder_prefix)) != $folder_prefix)){
		$subfolder_orig = $subfolder;
		$subfolder = $folder_prefix . $subfolder;
	} else {
		$subfolder_orig = $subfolder;
	}

	if (trim($subfolder_orig) == '') {
		$mailbox = $folder_prefix.$folder_name; 
	} else {
		$mailbox = $subfolder.$delimiter.$folder_name;
	}
	// print "creating $mailbox ......";

	/*    if (strtolower($type) == 'noselect') {
	        $mailbox = $mailbox.$delimiter;
	    }
	*/

	if(!$addrule_error) {
		$imapConnection = sqimap_login($username, $_COOKIE['key'], $imapServerAddress, $imapPort, 0);
		sqimap_mailbox_create($imapConnection, $mailbox, '');
		$folder = $mailbox;
		session_register('folder');
		$newrule['folder'] = $mailbox;
	}
	/*    $read_ary = sqimap_run_command($imapConnection, "CREATE \"$mailbox\"",
	                                   false, $response, $message);
	*/

}






if(!$_POST['finished']) {

switch ($newrule['type']) { 
	case "1":
		$vars = array( 'address', 'addressrel');
		foreach($vars as $myvar) {
			$newrule[$myvar]= ${$myvar};
		}
		break;
	case "2":
		/* Decide how much of the items to use for the rule, based on
		 * the first zero variable to be found. */

		if(!$_POST['headermatch'][0]) {
			//print "Error: You _have_ to define something!";
		}

		if(false) {
			$addrule_error =  _("You have to define at least one header match text.");
		}
		
		for ($i=0; $i<sizeof($_POST['headermatch']) ; $i++) {
			if ($_POST['headermatch'][$i]) {
				//print "<p><em>START PROC</em>";
				$newrule['header'][$i] = trim($_POST['header'][$i]);
				$newrule['matchtype'][$i] = trim($_POST['matchtype'][$i]);
				$newrule['headermatch'][$i] = trim($_POST['headermatch'][$i]);
				if($i>0) {
					$newrule['condition'] = $_POST['condition'];
				}
				//print "<b>Added $i series</b><br>";
				//print "<p><em>END PROC</em>";

			} elseif (!$_POST['headermatch'][$i]) { /* End */
				break 1;
			} else {
				//print "Huh?"; 
			}
		}
		break;

	case "3":
		if($_POST['sizeamount']) {
			$vars = array( 'sizerel', 'sizeamount', 'sizeunit');
			foreach($vars as $myvar) {
				$newrule[$myvar]= $_POST[$myvar];
			}
		}
		break;

	case "4":
		$dont = "1";
		break;

	default:
		$dont = "1";
		break;
}

if($_POST['action'] && ($new_folder != "5b" )){
	switch ($_POST['action']) { 
		case "1": /* keep */
		case "2": /* discard */
			$vars = array( 'action');
			break;
		case "3": /* reject w/ excuse */
			$vars = array( 'action', 'excuse');
			break;
		case "4": /* redirect */
			$vars = array( 'action', 'redirectemail');
			break;
		case "5": /* fileinto */
			$vars = array( 'action', 'keepdeleted');
			if($_POST['newfolder'] != "5b") {
				$vars = array_merge($vars, array('folder'));
			}
			break;
		case "6": /* vacation */
			$vars = array( 'action', 'vac_addresses', 'vac_days', 'vac_message');
			break;
		default:
			print "Invalid action value!";
			break;
	}
	if($_POST['stop']) {
		$vars = array_merge($vars, array('stop'));
	}
	if($_POST['notifyme']) {
		$vars = array_merge($vars, array('notify'));
	}

	foreach($vars as $myvar) {
		//print "DEBUG: Putting vars to our session array... sess[".$myvar."] = ".${$myvar}." <br />"; 
		$newrule[$myvar]= $_POST[$myvar];
	}
}

} /* !$_POST['finished'] */

if($_POST['finished'] || $_POST['apply']) {

	/* New rule to transfer to table.php: */
	$_SESSION['returnnewrule'] = $newrule;
	// urlencode(base64_encode(serialize($_SESSION['sess'])));

	/* Communication: */
	$_SESSION['comm']['new'] = true;

	/* Remove addrule.php stuff */
	session_unregister('sess');
	session_unregister('part');

	/* go to table.php */
	session_write_close();
	header('Location: table.php');
	exit;
}

if(isset($newrule)) {
	$_SESSION['sess'] = $newrule;
}

session_write_close();
// session_register('part');
/* END SESSION CODE */

/* -------------------------------- start printing ---------------------------------- */

displayPageHeader($color, 'None');

$currentdir = getcwd();
/* Second one (else) is always true, just to check a bit for strange
situations... */
if (defined("SM_PATH")) {
	$prev = bindtextdomain ('avelsieve', SM_PATH . 'plugins/avelsieve/locale');
} elseif (strstr($currentdir, "avelsieve")) {
	$prev = bindtextdomain ('avelsieve', $currentdir.'/locale');
} else {
	$prev = bindtextdomain ('avelsieve', $currentdir.'/avelsieve/locale');
}

textdomain ('avelsieve');
	
if(!defined('SM_PATH')) {
	chdir ('avelsieve');
}
require_once "constants.php";

if(!defined('SM_PATH')) {
	chdir ('..');
}

printheader2("New Rule");
avelsieve_printheader();
print_all_sections_start();

/* BEGIN DEBUG CODE */
//print "<pre> DEBUG: Session "; print_r($_SESSION); print "</pre>";
//print "<pre> DEBUG: HTTP Post "; print_r($_POST); print "</pre>";

//print $default_folder_prefix;
//print "folder_prefix = getPref($data_dir, $username, 'folder_prefix', $default_folder_prefix)";
//$folder_prefix = getPref($data_dir, $username, 'folder_prefix', $default_folder_prefix);
//print "FP: ".$folder_prefix;

/* END DEBUG CODE */

switch ($part) {

case "1":
	print_section_start( _("New Rule Wizard - Step") . " " . $part . " " . _("of") . " 4: " . _("Rule Type") );
	print_1_ruletype();
	break;

case "2":	
	print_section_start( _("New Rule Wizard - Step") . " " . $part . " " . _("of") . " 4: " . _("Condition") );
	switch ($newrule['type']) { /* Nested switch: The second step depends on the type of the first step. */
	
		case "1":
			print_2_1_addressmatch();
			break;

		case "2":
			print_2_2_headermatch($items);
			break;

		case "3":
			print_2_3_sizematch();
			break;

		case "4": /* redundant */
			print 'Move on to the next step. Nothing to see here. :-)';
			break;

		default:
			print 'Oops, some error here. This shouldnt have happened.';
			print $newrule['type'];
			printnakedfooter();
			exit;
			break;

		}
	break;		/* Im getting dizzy */


case "3":

	global $mailboxlist, $edunetmode, $delimiter;

	if(isset($_SESSION['delimiter'])) {
		$delimiter = $_SESSION['delimiter'];
	} else { /* These aren't likely to be executed.. just in case... */
		$delimiter = sqimap_get_delimiter($imapConnection);
		$_SESSION['delimiter'] = $delimiter;
	}

	// $cleartext_password = OneTimePadDecrypt($key, $onetimepad);
	// $folder_prefix = "INBOX";
	$imapConnection = sqimap_login($username, $_COOKIE['key'], $imapServerAddress, $imapPort, 1); 
	$boxes = sqimap_mailbox_list($imapConnection);
	sqimap_logout($imapConnection); 
	
	if ($edunetmode) {
		if ($_SESSION['prefs_cache']['alternateemails']) {
			for ($i=0; $i<$_SESSION['prefs_cache']['alternateemails']['count']; $i++) {
				$addressarray[] = $_SESSION['prefs_cache']['alternateemails'][$i];
			}
			$emailaddresses = implode(",", $addressarray);
		} else {
			$emailaddresses = getPref($data_dir, $username, 'email_address');
		}
		
	} else {
		$emailaddresses = getPref($data_dir, $username, 'email_address');
	}
	
	print_section_start( _("New Rule Wizard - Step") . " " . $part . " " . _("of") . " 4: " . _("Action") );
	
	print_3_action();
	break;


case "4":
	$sieverule = makesinglerule($newrule,"rule");
	$text = makesinglerule($newrule,"verbose");
	
	print_section_start( _("New Rule Wizard - Step") . " " . $part . " " . _("of") . " 4: " . _("Confirmation") );

	if($newrule['type']==4 && $newrule['action']==1 && !$newrule['notify']) {
		print _("<p>You have chosen to keep every mail. This is the default action anyway, so you might want to start over with a rule that makes more sense. Select &quot;finished&quot; to save this rule nonetheless.</p>");
		break;
	}
	
	print_4_confirmation();
	break;

default:
	print '<p>';
	print _("Please use the buttons on the bottom instead of your browser's reload, back and forward buttons, to build a rule.");
	print '</p>';
	break;

}

print_section_end();
print_all_sections_end();
printaddbuttons();
printfooter2();

?>
