<?php
/*
 * User-friendly interface to SIEVE server-side mail filtering.
 * Plugin for Squirrelmail 1.2+
 *
 * Copyright (c) 2002-2003 Alexandros Vellis <avel@users.sourceforge.net>
 *
 * Licensed under the GNU GPL. For full terms see the file COPYING that came
 * with the Squirrelmail distribution.
 *
 */

/* Various support functions, useful or useless.  NB. THEY MUST NOT DEPEND
 * ELSEWHERE.*/

/* Version checking... */

function avelsieve_check_SM_version ($a = '0', $b = '0', $c = '0') {

       global $version;

       list($aa, $bb, $cc) = preg_split('/\./', $version, 3);

       if(!is_numeric($cc)) {
           list($cc, $info) = explode(" ", $cc, 2);
       }

       return ($aa > $a)
           || (($aa == $a) && ($bb > $b))
           || (($aa == $a) && ($bb == $b) && ($cc >= $c));
}

/* Array functions */

function array_del($array, $place) {

	$newarray = array();
	$n=0;
	for ($i=0; $i<sizeof($array); $i++)
		if ($i!=$place) 
			$newarray[$n++] = $array[$i];
	return $newarray;
} 


function array_swapval ($array, $i, $j) {

	$temp[$i] = $array[$j];
	$temp[$j] = $array[$i];

	$array[$i] = $temp[$i];
	$array[$j] = $temp[$j];

	return $array;

}

function print_errormsg($errormsg) {

	printheader2(_("Error Encountered"));
	print_all_sections_start();
	print_section_start(_("Error Encountered"));
	// print_create_new();
	print $errormsg;
	print_section_end(); 
	print_all_sections_end();
	printfooter2();
	exit;

}


if (!avelsieve_check_SM_version(1,3,2) && !function_exists("sqgetGlobalVar")) { 


function sqgetGlobalVar($name, &$value, $search = SQ_INORDER) {
    if ( !check_php_version(4,1) ) {
        global $_SESSION, $_GET, $_POST, $_COOKIE, $_SERVER;
    }
    
    switch ($search) {
        /* we want the default case to be first here,  
	   so that if a valid value isn't specified, 
	   all three arrays will be searched. */
	default:
	case 'SQ_INORDER':
	case 'SQ_SESSION':
	  if( isset($_SESSION[$name]) ) {
            $value = $_SESSION[$name];
	    return TRUE;
          } elseif ( $search == SQ_SESSION ) {
	    break;
	  }
	case 'SQ_POST':
	  if( isset($_POST[$name]) ) {
            $value = $_POST[$name];
	    return TRUE;
	  } elseif ( $search == SQ_POST ) {
	    break;
	  }
       	case 'SQ_GET':
	  if ( isset($_GET[$name]) ) {
            $value = $_GET[$name];
	    return TRUE;
	  } 
	  /* NO IF HERE. FOR SQ_INORDER CASE, EXIT after GET */
	  break;
        case 'SQ_COOKIE':
          if ( isset($_COOKIE[$name]) ) {
             $value = $_COOKIE[$name];
             return TRUE;
          }
	  break;
	case 'SQ_SERVER':
          if ( isset($_SERVER[$name]) ) {
             $value = $_SERVER[$name];
             return TRUE;
          }
          break;
    }
    return FALSE;
}

}


?>
